{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postDisputesDisputeClose
module StripeAPI.Operations.PostDisputesDisputeClose where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/disputes/{dispute}/close
--
-- \<p>Closing the dispute for a charge indicates that you do not have any evidence to submit and are essentially dismissing the dispute, acknowledging it as lost.\<\/p>
--
-- \<p>The status of the dispute will change from \<code>needs_response\<\/code> to \<code>lost\<\/code>. \<em>Closing a dispute is irreversible\<\/em>.\<\/p>
postDisputesDisputeClose ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | dispute | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostDisputesDisputeCloseRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostDisputesDisputeCloseResponse)
postDisputesDisputeClose
  dispute
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostDisputesDisputeCloseResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostDisputesDisputeCloseResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Dispute
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostDisputesDisputeCloseResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/disputes/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel dispute)) GHC.Base.++ "/close"))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/disputes\/{dispute}\/close.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostDisputesDisputeCloseRequestBody = PostDisputesDisputeCloseRequestBody
  { -- | expand: Specifies which fields in the response should be expanded.
    postDisputesDisputeCloseRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostDisputesDisputeCloseRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object ("expand" Data.Aeson.Types.ToJSON..= postDisputesDisputeCloseRequestBodyExpand obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("expand" Data.Aeson.Types.ToJSON..= postDisputesDisputeCloseRequestBodyExpand obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostDisputesDisputeCloseRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostDisputesDisputeCloseRequestBody" (\obj -> GHC.Base.pure PostDisputesDisputeCloseRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expand"))

-- | Create a new 'PostDisputesDisputeCloseRequestBody' with all required fields.
mkPostDisputesDisputeCloseRequestBody :: PostDisputesDisputeCloseRequestBody
mkPostDisputesDisputeCloseRequestBody = PostDisputesDisputeCloseRequestBody {postDisputesDisputeCloseRequestBodyExpand = GHC.Maybe.Nothing}

-- | Represents a response of the operation 'postDisputesDisputeClose'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostDisputesDisputeCloseResponseError' is used.
data PostDisputesDisputeCloseResponse
  = -- | Means either no matching case available or a parse error
    PostDisputesDisputeCloseResponseError GHC.Base.String
  | -- | Successful response.
    PostDisputesDisputeCloseResponse200 Dispute
  | -- | Error response.
    PostDisputesDisputeCloseResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
