{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema AccountTosAcceptance
module StripeAPI.Types.AccountTosAcceptance where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.account_tos_acceptance@ in the specification.
data AccountTosAcceptance = AccountTosAcceptance
  { -- | date: The Unix timestamp marking when the account representative accepted their service agreement
    accountTosAcceptanceDate :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | ip: The IP address from which the account representative accepted their service agreement
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    accountTosAcceptanceIp :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | service_agreement: The user\'s service agreement type
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    accountTosAcceptanceServiceAgreement :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | user_agent: The user agent of the browser from which the account representative accepted their service agreement
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    accountTosAcceptanceUserAgent :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON AccountTosAcceptance where
  toJSON obj = Data.Aeson.Types.Internal.object ("date" Data.Aeson.Types.ToJSON..= accountTosAcceptanceDate obj : "ip" Data.Aeson.Types.ToJSON..= accountTosAcceptanceIp obj : "service_agreement" Data.Aeson.Types.ToJSON..= accountTosAcceptanceServiceAgreement obj : "user_agent" Data.Aeson.Types.ToJSON..= accountTosAcceptanceUserAgent obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("date" Data.Aeson.Types.ToJSON..= accountTosAcceptanceDate obj) GHC.Base.<> (("ip" Data.Aeson.Types.ToJSON..= accountTosAcceptanceIp obj) GHC.Base.<> (("service_agreement" Data.Aeson.Types.ToJSON..= accountTosAcceptanceServiceAgreement obj) GHC.Base.<> ("user_agent" Data.Aeson.Types.ToJSON..= accountTosAcceptanceUserAgent obj))))

instance Data.Aeson.Types.FromJSON.FromJSON AccountTosAcceptance where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "AccountTosAcceptance" (\obj -> (((GHC.Base.pure AccountTosAcceptance GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "date")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "ip")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "service_agreement")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "user_agent"))

-- | Create a new 'AccountTosAcceptance' with all required fields.
mkAccountTosAcceptance :: AccountTosAcceptance
mkAccountTosAcceptance =
  AccountTosAcceptance
    { accountTosAcceptanceDate = GHC.Maybe.Nothing,
      accountTosAcceptanceIp = GHC.Maybe.Nothing,
      accountTosAcceptanceServiceAgreement = GHC.Maybe.Nothing,
      accountTosAcceptanceUserAgent = GHC.Maybe.Nothing
    }
