{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema GelatoDocumentReportError
module StripeAPI.Types.GelatoDocumentReportError where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.gelato_document_report_error@ in the specification.
data GelatoDocumentReportError = GelatoDocumentReportError
  { -- | code: A short machine-readable string giving the reason for the verification failure.
    gelatoDocumentReportErrorCode :: (GHC.Maybe.Maybe GelatoDocumentReportErrorCode'),
    -- | reason: A human-readable message giving the reason for the failure. These messages can be shown to your users.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    gelatoDocumentReportErrorReason :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GelatoDocumentReportError where
  toJSON obj = Data.Aeson.Types.Internal.object ("code" Data.Aeson.Types.ToJSON..= gelatoDocumentReportErrorCode obj : "reason" Data.Aeson.Types.ToJSON..= gelatoDocumentReportErrorReason obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("code" Data.Aeson.Types.ToJSON..= gelatoDocumentReportErrorCode obj) GHC.Base.<> ("reason" Data.Aeson.Types.ToJSON..= gelatoDocumentReportErrorReason obj))

instance Data.Aeson.Types.FromJSON.FromJSON GelatoDocumentReportError where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GelatoDocumentReportError" (\obj -> (GHC.Base.pure GelatoDocumentReportError GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "reason"))

-- | Create a new 'GelatoDocumentReportError' with all required fields.
mkGelatoDocumentReportError :: GelatoDocumentReportError
mkGelatoDocumentReportError =
  GelatoDocumentReportError
    { gelatoDocumentReportErrorCode = GHC.Maybe.Nothing,
      gelatoDocumentReportErrorReason = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.gelato_document_report_error.properties.code@ in the specification.
--
-- A short machine-readable string giving the reason for the verification failure.
data GelatoDocumentReportErrorCode'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GelatoDocumentReportErrorCode'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GelatoDocumentReportErrorCode'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"document_expired"@
    GelatoDocumentReportErrorCode'EnumDocumentExpired
  | -- | Represents the JSON value @"document_type_not_supported"@
    GelatoDocumentReportErrorCode'EnumDocumentTypeNotSupported
  | -- | Represents the JSON value @"document_unverified_other"@
    GelatoDocumentReportErrorCode'EnumDocumentUnverifiedOther
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GelatoDocumentReportErrorCode' where
  toJSON (GelatoDocumentReportErrorCode'Other val) = val
  toJSON (GelatoDocumentReportErrorCode'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GelatoDocumentReportErrorCode'EnumDocumentExpired) = "document_expired"
  toJSON (GelatoDocumentReportErrorCode'EnumDocumentTypeNotSupported) = "document_type_not_supported"
  toJSON (GelatoDocumentReportErrorCode'EnumDocumentUnverifiedOther) = "document_unverified_other"

instance Data.Aeson.Types.FromJSON.FromJSON GelatoDocumentReportErrorCode' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "document_expired" -> GelatoDocumentReportErrorCode'EnumDocumentExpired
            | val GHC.Classes.== "document_type_not_supported" -> GelatoDocumentReportErrorCode'EnumDocumentTypeNotSupported
            | val GHC.Classes.== "document_unverified_other" -> GelatoDocumentReportErrorCode'EnumDocumentUnverifiedOther
            | GHC.Base.otherwise -> GelatoDocumentReportErrorCode'Other val
      )
