{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema GelatoSelfieReport
module StripeAPI.Types.GelatoSelfieReport where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.GelatoSelfieReportError
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.gelato_selfie_report@ in the specification.
--
-- Result from a selfie check
data GelatoSelfieReport = GelatoSelfieReport
  { -- | document: ID of the [File](https:\/\/stripe.com\/docs\/api\/files) holding the image of the identity document used in this check.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    gelatoSelfieReportDocument :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | error: Details on the verification error. Present when status is \`unverified\`.
    gelatoSelfieReportError :: (GHC.Maybe.Maybe GelatoSelfieReportError'),
    -- | selfie: ID of the [File](https:\/\/stripe.com\/docs\/api\/files) holding the image of the selfie used in this check.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    gelatoSelfieReportSelfie :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | status: Status of this \`selfie\` check.
    gelatoSelfieReportStatus :: GelatoSelfieReportStatus'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSelfieReport where
  toJSON obj = Data.Aeson.Types.Internal.object ("document" Data.Aeson.Types.ToJSON..= gelatoSelfieReportDocument obj : "error" Data.Aeson.Types.ToJSON..= gelatoSelfieReportError obj : "selfie" Data.Aeson.Types.ToJSON..= gelatoSelfieReportSelfie obj : "status" Data.Aeson.Types.ToJSON..= gelatoSelfieReportStatus obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("document" Data.Aeson.Types.ToJSON..= gelatoSelfieReportDocument obj) GHC.Base.<> (("error" Data.Aeson.Types.ToJSON..= gelatoSelfieReportError obj) GHC.Base.<> (("selfie" Data.Aeson.Types.ToJSON..= gelatoSelfieReportSelfie obj) GHC.Base.<> ("status" Data.Aeson.Types.ToJSON..= gelatoSelfieReportStatus obj))))

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSelfieReport where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GelatoSelfieReport" (\obj -> (((GHC.Base.pure GelatoSelfieReport GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "document")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "error")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "selfie")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status"))

-- | Create a new 'GelatoSelfieReport' with all required fields.
mkGelatoSelfieReport ::
  -- | 'gelatoSelfieReportStatus'
  GelatoSelfieReportStatus' ->
  GelatoSelfieReport
mkGelatoSelfieReport gelatoSelfieReportStatus =
  GelatoSelfieReport
    { gelatoSelfieReportDocument = GHC.Maybe.Nothing,
      gelatoSelfieReportError = GHC.Maybe.Nothing,
      gelatoSelfieReportSelfie = GHC.Maybe.Nothing,
      gelatoSelfieReportStatus = gelatoSelfieReportStatus
    }

-- | Defines the object schema located at @components.schemas.gelato_selfie_report.properties.error.anyOf@ in the specification.
--
-- Details on the verification error. Present when status is \\\`unverified\\\`.
data GelatoSelfieReportError' = GelatoSelfieReportError'
  { -- | code: A short machine-readable string giving the reason for the verification failure.
    gelatoSelfieReportError'Code :: (GHC.Maybe.Maybe GelatoSelfieReportError'Code'),
    -- | reason: A human-readable message giving the reason for the failure. These messages can be shown to your users.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    gelatoSelfieReportError'Reason :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSelfieReportError' where
  toJSON obj = Data.Aeson.Types.Internal.object ("code" Data.Aeson.Types.ToJSON..= gelatoSelfieReportError'Code obj : "reason" Data.Aeson.Types.ToJSON..= gelatoSelfieReportError'Reason obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("code" Data.Aeson.Types.ToJSON..= gelatoSelfieReportError'Code obj) GHC.Base.<> ("reason" Data.Aeson.Types.ToJSON..= gelatoSelfieReportError'Reason obj))

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSelfieReportError' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GelatoSelfieReportError'" (\obj -> (GHC.Base.pure GelatoSelfieReportError' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "reason"))

-- | Create a new 'GelatoSelfieReportError'' with all required fields.
mkGelatoSelfieReportError' :: GelatoSelfieReportError'
mkGelatoSelfieReportError' =
  GelatoSelfieReportError'
    { gelatoSelfieReportError'Code = GHC.Maybe.Nothing,
      gelatoSelfieReportError'Reason = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.gelato_selfie_report.properties.error.anyOf.properties.code@ in the specification.
--
-- A short machine-readable string giving the reason for the verification failure.
data GelatoSelfieReportError'Code'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GelatoSelfieReportError'Code'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GelatoSelfieReportError'Code'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"selfie_document_missing_photo"@
    GelatoSelfieReportError'Code'EnumSelfieDocumentMissingPhoto
  | -- | Represents the JSON value @"selfie_face_mismatch"@
    GelatoSelfieReportError'Code'EnumSelfieFaceMismatch
  | -- | Represents the JSON value @"selfie_manipulated"@
    GelatoSelfieReportError'Code'EnumSelfieManipulated
  | -- | Represents the JSON value @"selfie_unverified_other"@
    GelatoSelfieReportError'Code'EnumSelfieUnverifiedOther
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSelfieReportError'Code' where
  toJSON (GelatoSelfieReportError'Code'Other val) = val
  toJSON (GelatoSelfieReportError'Code'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GelatoSelfieReportError'Code'EnumSelfieDocumentMissingPhoto) = "selfie_document_missing_photo"
  toJSON (GelatoSelfieReportError'Code'EnumSelfieFaceMismatch) = "selfie_face_mismatch"
  toJSON (GelatoSelfieReportError'Code'EnumSelfieManipulated) = "selfie_manipulated"
  toJSON (GelatoSelfieReportError'Code'EnumSelfieUnverifiedOther) = "selfie_unverified_other"

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSelfieReportError'Code' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "selfie_document_missing_photo" -> GelatoSelfieReportError'Code'EnumSelfieDocumentMissingPhoto
            | val GHC.Classes.== "selfie_face_mismatch" -> GelatoSelfieReportError'Code'EnumSelfieFaceMismatch
            | val GHC.Classes.== "selfie_manipulated" -> GelatoSelfieReportError'Code'EnumSelfieManipulated
            | val GHC.Classes.== "selfie_unverified_other" -> GelatoSelfieReportError'Code'EnumSelfieUnverifiedOther
            | GHC.Base.otherwise -> GelatoSelfieReportError'Code'Other val
      )

-- | Defines the enum schema located at @components.schemas.gelato_selfie_report.properties.status@ in the specification.
--
-- Status of this \`selfie\` check.
data GelatoSelfieReportStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    GelatoSelfieReportStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    GelatoSelfieReportStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"unverified"@
    GelatoSelfieReportStatus'EnumUnverified
  | -- | Represents the JSON value @"verified"@
    GelatoSelfieReportStatus'EnumVerified
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON GelatoSelfieReportStatus' where
  toJSON (GelatoSelfieReportStatus'Other val) = val
  toJSON (GelatoSelfieReportStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (GelatoSelfieReportStatus'EnumUnverified) = "unverified"
  toJSON (GelatoSelfieReportStatus'EnumVerified) = "verified"

instance Data.Aeson.Types.FromJSON.FromJSON GelatoSelfieReportStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "unverified" -> GelatoSelfieReportStatus'EnumUnverified
            | val GHC.Classes.== "verified" -> GelatoSelfieReportStatus'EnumVerified
            | GHC.Base.otherwise -> GelatoSelfieReportStatus'Other val
      )
