{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuingAuthorizationPendingRequest
module StripeAPI.Types.IssuingAuthorizationPendingRequest where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.IssuingAuthorizationAmountDetails
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing_authorization_pending_request@ in the specification.
data IssuingAuthorizationPendingRequest = IssuingAuthorizationPendingRequest
  { -- | amount: The additional amount Stripe will hold if the authorization is approved, in the card\'s [currency](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-pending-request-currency) and in the [smallest currency unit](https:\/\/stripe.com\/docs\/currencies\#zero-decimal).
    issuingAuthorizationPendingRequestAmount :: GHC.Types.Int,
    -- | amount_details: Detailed breakdown of amount components. These amounts are denominated in \`currency\` and in the [smallest currency unit](https:\/\/stripe.com\/docs\/currencies\#zero-decimal).
    issuingAuthorizationPendingRequestAmountDetails :: (GHC.Maybe.Maybe IssuingAuthorizationPendingRequestAmountDetails'),
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    issuingAuthorizationPendingRequestCurrency :: Data.Text.Internal.Text,
    -- | is_amount_controllable: If set \`true\`, you may provide [amount](https:\/\/stripe.com\/docs\/api\/issuing\/authorizations\/approve\#approve_issuing_authorization-amount) to control how much to hold for the authorization.
    issuingAuthorizationPendingRequestIsAmountControllable :: GHC.Types.Bool,
    -- | merchant_amount: The amount the merchant is requesting to be authorized in the \`merchant_currency\`. The amount is in the [smallest currency unit](https:\/\/stripe.com\/docs\/currencies\#zero-decimal).
    issuingAuthorizationPendingRequestMerchantAmount :: GHC.Types.Int,
    -- | merchant_currency: The local currency the merchant is requesting to authorize.
    issuingAuthorizationPendingRequestMerchantCurrency :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingAuthorizationPendingRequest where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestAmount obj : "amount_details" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestAmountDetails obj : "currency" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestCurrency obj : "is_amount_controllable" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestIsAmountControllable obj : "merchant_amount" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestMerchantAmount obj : "merchant_currency" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestMerchantCurrency obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestAmount obj) GHC.Base.<> (("amount_details" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestAmountDetails obj) GHC.Base.<> (("currency" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestCurrency obj) GHC.Base.<> (("is_amount_controllable" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestIsAmountControllable obj) GHC.Base.<> (("merchant_amount" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestMerchantAmount obj) GHC.Base.<> ("merchant_currency" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestMerchantCurrency obj))))))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingAuthorizationPendingRequest where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingAuthorizationPendingRequest" (\obj -> (((((GHC.Base.pure IssuingAuthorizationPendingRequest GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "amount_details")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "is_amount_controllable")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "merchant_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "merchant_currency"))

-- | Create a new 'IssuingAuthorizationPendingRequest' with all required fields.
mkIssuingAuthorizationPendingRequest ::
  -- | 'issuingAuthorizationPendingRequestAmount'
  GHC.Types.Int ->
  -- | 'issuingAuthorizationPendingRequestCurrency'
  Data.Text.Internal.Text ->
  -- | 'issuingAuthorizationPendingRequestIsAmountControllable'
  GHC.Types.Bool ->
  -- | 'issuingAuthorizationPendingRequestMerchantAmount'
  GHC.Types.Int ->
  -- | 'issuingAuthorizationPendingRequestMerchantCurrency'
  Data.Text.Internal.Text ->
  IssuingAuthorizationPendingRequest
mkIssuingAuthorizationPendingRequest issuingAuthorizationPendingRequestAmount issuingAuthorizationPendingRequestCurrency issuingAuthorizationPendingRequestIsAmountControllable issuingAuthorizationPendingRequestMerchantAmount issuingAuthorizationPendingRequestMerchantCurrency =
  IssuingAuthorizationPendingRequest
    { issuingAuthorizationPendingRequestAmount = issuingAuthorizationPendingRequestAmount,
      issuingAuthorizationPendingRequestAmountDetails = GHC.Maybe.Nothing,
      issuingAuthorizationPendingRequestCurrency = issuingAuthorizationPendingRequestCurrency,
      issuingAuthorizationPendingRequestIsAmountControllable = issuingAuthorizationPendingRequestIsAmountControllable,
      issuingAuthorizationPendingRequestMerchantAmount = issuingAuthorizationPendingRequestMerchantAmount,
      issuingAuthorizationPendingRequestMerchantCurrency = issuingAuthorizationPendingRequestMerchantCurrency
    }

-- | Defines the object schema located at @components.schemas.issuing_authorization_pending_request.properties.amount_details.anyOf@ in the specification.
--
-- Detailed breakdown of amount components. These amounts are denominated in \\\`currency\\\` and in the [smallest currency unit](https:\\\/\\\/stripe.com\\\/docs\\\/currencies\\\#zero-decimal).
data IssuingAuthorizationPendingRequestAmountDetails' = IssuingAuthorizationPendingRequestAmountDetails'
  { -- | atm_fee: The fee charged by the ATM for the cash withdrawal.
    issuingAuthorizationPendingRequestAmountDetails'AtmFee :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingAuthorizationPendingRequestAmountDetails' where
  toJSON obj = Data.Aeson.Types.Internal.object ("atm_fee" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestAmountDetails'AtmFee obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("atm_fee" Data.Aeson.Types.ToJSON..= issuingAuthorizationPendingRequestAmountDetails'AtmFee obj)

instance Data.Aeson.Types.FromJSON.FromJSON IssuingAuthorizationPendingRequestAmountDetails' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingAuthorizationPendingRequestAmountDetails'" (\obj -> GHC.Base.pure IssuingAuthorizationPendingRequestAmountDetails' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "atm_fee"))

-- | Create a new 'IssuingAuthorizationPendingRequestAmountDetails'' with all required fields.
mkIssuingAuthorizationPendingRequestAmountDetails' :: IssuingAuthorizationPendingRequestAmountDetails'
mkIssuingAuthorizationPendingRequestAmountDetails' = IssuingAuthorizationPendingRequestAmountDetails' {issuingAuthorizationPendingRequestAmountDetails'AtmFee = GHC.Maybe.Nothing}
