{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema LineItemsTaxAmount
module StripeAPI.Types.LineItemsTaxAmount where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.TaxRate
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.line_items_tax_amount@ in the specification.
data LineItemsTaxAmount = LineItemsTaxAmount
  { -- | amount: Amount of tax applied for this rate.
    lineItemsTaxAmountAmount :: GHC.Types.Int,
    -- | rate: Tax rates can be applied to [invoices](https:\/\/stripe.com\/docs\/billing\/invoices\/tax-rates), [subscriptions](https:\/\/stripe.com\/docs\/billing\/subscriptions\/taxes) and [Checkout Sessions](https:\/\/stripe.com\/docs\/payments\/checkout\/set-up-a-subscription\#tax-rates) to collect tax.
    --
    -- Related guide: [Tax Rates](https:\/\/stripe.com\/docs\/billing\/taxes\/tax-rates).
    lineItemsTaxAmountRate :: TaxRate
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON LineItemsTaxAmount where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount" Data.Aeson.Types.ToJSON..= lineItemsTaxAmountAmount obj : "rate" Data.Aeson.Types.ToJSON..= lineItemsTaxAmountRate obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount" Data.Aeson.Types.ToJSON..= lineItemsTaxAmountAmount obj) GHC.Base.<> ("rate" Data.Aeson.Types.ToJSON..= lineItemsTaxAmountRate obj))

instance Data.Aeson.Types.FromJSON.FromJSON LineItemsTaxAmount where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "LineItemsTaxAmount" (\obj -> (GHC.Base.pure LineItemsTaxAmount GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "rate"))

-- | Create a new 'LineItemsTaxAmount' with all required fields.
mkLineItemsTaxAmount ::
  -- | 'lineItemsTaxAmountAmount'
  GHC.Types.Int ->
  -- | 'lineItemsTaxAmountRate'
  TaxRate ->
  LineItemsTaxAmount
mkLineItemsTaxAmount lineItemsTaxAmountAmount lineItemsTaxAmountRate =
  LineItemsTaxAmount
    { lineItemsTaxAmountAmount = lineItemsTaxAmountAmount,
      lineItemsTaxAmountRate = lineItemsTaxAmountRate
    }
