{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentMethodOptionsSofort
module StripeAPI.Types.PaymentMethodOptionsSofort where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_method_options_sofort@ in the specification.
data PaymentMethodOptionsSofort = PaymentMethodOptionsSofort
  { -- | preferred_language: Preferred language of the SOFORT authorization page that the customer is redirected to.
    paymentMethodOptionsSofortPreferredLanguage :: (GHC.Maybe.Maybe PaymentMethodOptionsSofortPreferredLanguage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsSofort where
  toJSON obj = Data.Aeson.Types.Internal.object ("preferred_language" Data.Aeson.Types.ToJSON..= paymentMethodOptionsSofortPreferredLanguage obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("preferred_language" Data.Aeson.Types.ToJSON..= paymentMethodOptionsSofortPreferredLanguage obj)

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsSofort where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentMethodOptionsSofort" (\obj -> GHC.Base.pure PaymentMethodOptionsSofort GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "preferred_language"))

-- | Create a new 'PaymentMethodOptionsSofort' with all required fields.
mkPaymentMethodOptionsSofort :: PaymentMethodOptionsSofort
mkPaymentMethodOptionsSofort = PaymentMethodOptionsSofort {paymentMethodOptionsSofortPreferredLanguage = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @components.schemas.payment_method_options_sofort.properties.preferred_language@ in the specification.
--
-- Preferred language of the SOFORT authorization page that the customer is redirected to.
data PaymentMethodOptionsSofortPreferredLanguage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentMethodOptionsSofortPreferredLanguage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentMethodOptionsSofortPreferredLanguage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"de"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumDe
  | -- | Represents the JSON value @"en"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumEn
  | -- | Represents the JSON value @"es"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumEs
  | -- | Represents the JSON value @"fr"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumFr
  | -- | Represents the JSON value @"it"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumIt
  | -- | Represents the JSON value @"nl"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumNl
  | -- | Represents the JSON value @"pl"@
    PaymentMethodOptionsSofortPreferredLanguage'EnumPl
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsSofortPreferredLanguage' where
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'Other val) = val
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumDe) = "de"
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumEn) = "en"
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumEs) = "es"
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumFr) = "fr"
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumIt) = "it"
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumNl) = "nl"
  toJSON (PaymentMethodOptionsSofortPreferredLanguage'EnumPl) = "pl"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsSofortPreferredLanguage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "de" -> PaymentMethodOptionsSofortPreferredLanguage'EnumDe
            | val GHC.Classes.== "en" -> PaymentMethodOptionsSofortPreferredLanguage'EnumEn
            | val GHC.Classes.== "es" -> PaymentMethodOptionsSofortPreferredLanguage'EnumEs
            | val GHC.Classes.== "fr" -> PaymentMethodOptionsSofortPreferredLanguage'EnumFr
            | val GHC.Classes.== "it" -> PaymentMethodOptionsSofortPreferredLanguage'EnumIt
            | val GHC.Classes.== "nl" -> PaymentMethodOptionsSofortPreferredLanguage'EnumNl
            | val GHC.Classes.== "pl" -> PaymentMethodOptionsSofortPreferredLanguage'EnumPl
            | GHC.Base.otherwise -> PaymentMethodOptionsSofortPreferredLanguage'Other val
      )
