{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentPagesCheckoutSessionCustomerDetails
module StripeAPI.Types.PaymentPagesCheckoutSessionCustomerDetails where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.PaymentPagesCheckoutSessionTaxId
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_pages_checkout_session_customer_details@ in the specification.
data PaymentPagesCheckoutSessionCustomerDetails = PaymentPagesCheckoutSessionCustomerDetails
  { -- | email: The customer’s email at time of checkout.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentPagesCheckoutSessionCustomerDetailsEmail :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | tax_exempt: The customer’s tax exempt status at time of checkout.
    paymentPagesCheckoutSessionCustomerDetailsTaxExempt :: (GHC.Maybe.Maybe PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'),
    -- | tax_ids: The customer’s tax IDs at time of checkout.
    paymentPagesCheckoutSessionCustomerDetailsTaxIds :: (GHC.Maybe.Maybe ([PaymentPagesCheckoutSessionTaxId]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentPagesCheckoutSessionCustomerDetails where
  toJSON obj = Data.Aeson.Types.Internal.object ("email" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionCustomerDetailsEmail obj : "tax_exempt" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionCustomerDetailsTaxExempt obj : "tax_ids" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionCustomerDetailsTaxIds obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("email" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionCustomerDetailsEmail obj) GHC.Base.<> (("tax_exempt" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionCustomerDetailsTaxExempt obj) GHC.Base.<> ("tax_ids" Data.Aeson.Types.ToJSON..= paymentPagesCheckoutSessionCustomerDetailsTaxIds obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentPagesCheckoutSessionCustomerDetails where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentPagesCheckoutSessionCustomerDetails" (\obj -> ((GHC.Base.pure PaymentPagesCheckoutSessionCustomerDetails GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_exempt")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_ids"))

-- | Create a new 'PaymentPagesCheckoutSessionCustomerDetails' with all required fields.
mkPaymentPagesCheckoutSessionCustomerDetails :: PaymentPagesCheckoutSessionCustomerDetails
mkPaymentPagesCheckoutSessionCustomerDetails =
  PaymentPagesCheckoutSessionCustomerDetails
    { paymentPagesCheckoutSessionCustomerDetailsEmail = GHC.Maybe.Nothing,
      paymentPagesCheckoutSessionCustomerDetailsTaxExempt = GHC.Maybe.Nothing,
      paymentPagesCheckoutSessionCustomerDetailsTaxIds = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_pages_checkout_session_customer_details.properties.tax_exempt@ in the specification.
--
-- The customer’s tax exempt status at time of checkout.
data PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"exempt"@
    PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumExempt
  | -- | Represents the JSON value @"none"@
    PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumNone
  | -- | Represents the JSON value @"reverse"@
    PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumReverse
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentPagesCheckoutSessionCustomerDetailsTaxExempt' where
  toJSON (PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'Other val) = val
  toJSON (PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumExempt) = "exempt"
  toJSON (PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumNone) = "none"
  toJSON (PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumReverse) = "reverse"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentPagesCheckoutSessionCustomerDetailsTaxExempt' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "exempt" -> PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumExempt
            | val GHC.Classes.== "none" -> PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumNone
            | val GHC.Classes.== "reverse" -> PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'EnumReverse
            | GHC.Base.otherwise -> PaymentPagesCheckoutSessionCustomerDetailsTaxExempt'Other val
      )
