{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PortalSubscriptionCancel
module StripeAPI.Types.PortalSubscriptionCancel where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.portal_subscription_cancel@ in the specification.
data PortalSubscriptionCancel = PortalSubscriptionCancel
  { -- | enabled: Whether the feature is enabled.
    portalSubscriptionCancelEnabled :: GHC.Types.Bool,
    -- | mode: Whether to cancel subscriptions immediately or at the end of the billing period.
    portalSubscriptionCancelMode :: PortalSubscriptionCancelMode',
    -- | proration_behavior: Whether to create prorations when canceling subscriptions. Possible values are \`none\` and \`create_prorations\`.
    portalSubscriptionCancelProrationBehavior :: PortalSubscriptionCancelProrationBehavior'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PortalSubscriptionCancel where
  toJSON obj = Data.Aeson.Types.Internal.object ("enabled" Data.Aeson.Types.ToJSON..= portalSubscriptionCancelEnabled obj : "mode" Data.Aeson.Types.ToJSON..= portalSubscriptionCancelMode obj : "proration_behavior" Data.Aeson.Types.ToJSON..= portalSubscriptionCancelProrationBehavior obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("enabled" Data.Aeson.Types.ToJSON..= portalSubscriptionCancelEnabled obj) GHC.Base.<> (("mode" Data.Aeson.Types.ToJSON..= portalSubscriptionCancelMode obj) GHC.Base.<> ("proration_behavior" Data.Aeson.Types.ToJSON..= portalSubscriptionCancelProrationBehavior obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PortalSubscriptionCancel where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PortalSubscriptionCancel" (\obj -> ((GHC.Base.pure PortalSubscriptionCancel GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "mode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "proration_behavior"))

-- | Create a new 'PortalSubscriptionCancel' with all required fields.
mkPortalSubscriptionCancel ::
  -- | 'portalSubscriptionCancelEnabled'
  GHC.Types.Bool ->
  -- | 'portalSubscriptionCancelMode'
  PortalSubscriptionCancelMode' ->
  -- | 'portalSubscriptionCancelProrationBehavior'
  PortalSubscriptionCancelProrationBehavior' ->
  PortalSubscriptionCancel
mkPortalSubscriptionCancel portalSubscriptionCancelEnabled portalSubscriptionCancelMode portalSubscriptionCancelProrationBehavior =
  PortalSubscriptionCancel
    { portalSubscriptionCancelEnabled = portalSubscriptionCancelEnabled,
      portalSubscriptionCancelMode = portalSubscriptionCancelMode,
      portalSubscriptionCancelProrationBehavior = portalSubscriptionCancelProrationBehavior
    }

-- | Defines the enum schema located at @components.schemas.portal_subscription_cancel.properties.mode@ in the specification.
--
-- Whether to cancel subscriptions immediately or at the end of the billing period.
data PortalSubscriptionCancelMode'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PortalSubscriptionCancelMode'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PortalSubscriptionCancelMode'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"at_period_end"@
    PortalSubscriptionCancelMode'EnumAtPeriodEnd
  | -- | Represents the JSON value @"immediately"@
    PortalSubscriptionCancelMode'EnumImmediately
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PortalSubscriptionCancelMode' where
  toJSON (PortalSubscriptionCancelMode'Other val) = val
  toJSON (PortalSubscriptionCancelMode'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PortalSubscriptionCancelMode'EnumAtPeriodEnd) = "at_period_end"
  toJSON (PortalSubscriptionCancelMode'EnumImmediately) = "immediately"

instance Data.Aeson.Types.FromJSON.FromJSON PortalSubscriptionCancelMode' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "at_period_end" -> PortalSubscriptionCancelMode'EnumAtPeriodEnd
            | val GHC.Classes.== "immediately" -> PortalSubscriptionCancelMode'EnumImmediately
            | GHC.Base.otherwise -> PortalSubscriptionCancelMode'Other val
      )

-- | Defines the enum schema located at @components.schemas.portal_subscription_cancel.properties.proration_behavior@ in the specification.
--
-- Whether to create prorations when canceling subscriptions. Possible values are \`none\` and \`create_prorations\`.
data PortalSubscriptionCancelProrationBehavior'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PortalSubscriptionCancelProrationBehavior'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PortalSubscriptionCancelProrationBehavior'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"always_invoice"@
    PortalSubscriptionCancelProrationBehavior'EnumAlwaysInvoice
  | -- | Represents the JSON value @"create_prorations"@
    PortalSubscriptionCancelProrationBehavior'EnumCreateProrations
  | -- | Represents the JSON value @"none"@
    PortalSubscriptionCancelProrationBehavior'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PortalSubscriptionCancelProrationBehavior' where
  toJSON (PortalSubscriptionCancelProrationBehavior'Other val) = val
  toJSON (PortalSubscriptionCancelProrationBehavior'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PortalSubscriptionCancelProrationBehavior'EnumAlwaysInvoice) = "always_invoice"
  toJSON (PortalSubscriptionCancelProrationBehavior'EnumCreateProrations) = "create_prorations"
  toJSON (PortalSubscriptionCancelProrationBehavior'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PortalSubscriptionCancelProrationBehavior' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "always_invoice" -> PortalSubscriptionCancelProrationBehavior'EnumAlwaysInvoice
            | val GHC.Classes.== "create_prorations" -> PortalSubscriptionCancelProrationBehavior'EnumCreateProrations
            | val GHC.Classes.== "none" -> PortalSubscriptionCancelProrationBehavior'EnumNone
            | GHC.Base.otherwise -> PortalSubscriptionCancelProrationBehavior'Other val
      )
