{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema SetupIntentPaymentMethodOptionsAcssDebit
module StripeAPI.Types.SetupIntentPaymentMethodOptionsAcssDebit where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.SetupIntentPaymentMethodOptionsMandateOptionsAcssDebit
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.setup_intent_payment_method_options_acss_debit@ in the specification.
data SetupIntentPaymentMethodOptionsAcssDebit = SetupIntentPaymentMethodOptionsAcssDebit
  { -- | currency: Currency supported by the bank account
    setupIntentPaymentMethodOptionsAcssDebitCurrency :: (GHC.Maybe.Maybe SetupIntentPaymentMethodOptionsAcssDebitCurrency'),
    -- | mandate_options:
    setupIntentPaymentMethodOptionsAcssDebitMandateOptions :: (GHC.Maybe.Maybe SetupIntentPaymentMethodOptionsMandateOptionsAcssDebit),
    -- | verification_method: Bank account verification method.
    setupIntentPaymentMethodOptionsAcssDebitVerificationMethod :: (GHC.Maybe.Maybe SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON SetupIntentPaymentMethodOptionsAcssDebit where
  toJSON obj = Data.Aeson.Types.Internal.object ("currency" Data.Aeson.Types.ToJSON..= setupIntentPaymentMethodOptionsAcssDebitCurrency obj : "mandate_options" Data.Aeson.Types.ToJSON..= setupIntentPaymentMethodOptionsAcssDebitMandateOptions obj : "verification_method" Data.Aeson.Types.ToJSON..= setupIntentPaymentMethodOptionsAcssDebitVerificationMethod obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("currency" Data.Aeson.Types.ToJSON..= setupIntentPaymentMethodOptionsAcssDebitCurrency obj) GHC.Base.<> (("mandate_options" Data.Aeson.Types.ToJSON..= setupIntentPaymentMethodOptionsAcssDebitMandateOptions obj) GHC.Base.<> ("verification_method" Data.Aeson.Types.ToJSON..= setupIntentPaymentMethodOptionsAcssDebitVerificationMethod obj)))

instance Data.Aeson.Types.FromJSON.FromJSON SetupIntentPaymentMethodOptionsAcssDebit where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "SetupIntentPaymentMethodOptionsAcssDebit" (\obj -> ((GHC.Base.pure SetupIntentPaymentMethodOptionsAcssDebit GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "mandate_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "verification_method"))

-- | Create a new 'SetupIntentPaymentMethodOptionsAcssDebit' with all required fields.
mkSetupIntentPaymentMethodOptionsAcssDebit :: SetupIntentPaymentMethodOptionsAcssDebit
mkSetupIntentPaymentMethodOptionsAcssDebit =
  SetupIntentPaymentMethodOptionsAcssDebit
    { setupIntentPaymentMethodOptionsAcssDebitCurrency = GHC.Maybe.Nothing,
      setupIntentPaymentMethodOptionsAcssDebitMandateOptions = GHC.Maybe.Nothing,
      setupIntentPaymentMethodOptionsAcssDebitVerificationMethod = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.setup_intent_payment_method_options_acss_debit.properties.currency@ in the specification.
--
-- Currency supported by the bank account
data SetupIntentPaymentMethodOptionsAcssDebitCurrency'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    SetupIntentPaymentMethodOptionsAcssDebitCurrency'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    SetupIntentPaymentMethodOptionsAcssDebitCurrency'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"cad"@
    SetupIntentPaymentMethodOptionsAcssDebitCurrency'EnumCad
  | -- | Represents the JSON value @"usd"@
    SetupIntentPaymentMethodOptionsAcssDebitCurrency'EnumUsd
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON SetupIntentPaymentMethodOptionsAcssDebitCurrency' where
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitCurrency'Other val) = val
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitCurrency'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitCurrency'EnumCad) = "cad"
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitCurrency'EnumUsd) = "usd"

instance Data.Aeson.Types.FromJSON.FromJSON SetupIntentPaymentMethodOptionsAcssDebitCurrency' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "cad" -> SetupIntentPaymentMethodOptionsAcssDebitCurrency'EnumCad
            | val GHC.Classes.== "usd" -> SetupIntentPaymentMethodOptionsAcssDebitCurrency'EnumUsd
            | GHC.Base.otherwise -> SetupIntentPaymentMethodOptionsAcssDebitCurrency'Other val
      )

-- | Defines the enum schema located at @components.schemas.setup_intent_payment_method_options_acss_debit.properties.verification_method@ in the specification.
--
-- Bank account verification method.
data SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumAutomatic
  | -- | Represents the JSON value @"instant"@
    SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumInstant
  | -- | Represents the JSON value @"microdeposits"@
    SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumMicrodeposits
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod' where
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'Other val) = val
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumAutomatic) = "automatic"
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumInstant) = "instant"
  toJSON (SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumMicrodeposits) = "microdeposits"

instance Data.Aeson.Types.FromJSON.FromJSON SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumAutomatic
            | val GHC.Classes.== "instant" -> SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumInstant
            | val GHC.Classes.== "microdeposits" -> SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'EnumMicrodeposits
            | GHC.Base.otherwise -> SetupIntentPaymentMethodOptionsAcssDebitVerificationMethod'Other val
      )
