{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema SourceMandateNotificationSepaDebitData
module StripeAPI.Types.SourceMandateNotificationSepaDebitData where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.source_mandate_notification_sepa_debit_data@ in the specification.
data SourceMandateNotificationSepaDebitData = SourceMandateNotificationSepaDebitData
  { -- | creditor_identifier: SEPA creditor ID.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    sourceMandateNotificationSepaDebitDataCreditorIdentifier :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | last4: Last 4 digits of the account number associated with the debit.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    sourceMandateNotificationSepaDebitDataLast4 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | mandate_reference: Mandate reference associated with the debit.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    sourceMandateNotificationSepaDebitDataMandateReference :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON SourceMandateNotificationSepaDebitData where
  toJSON obj = Data.Aeson.Types.Internal.object ("creditor_identifier" Data.Aeson.Types.ToJSON..= sourceMandateNotificationSepaDebitDataCreditorIdentifier obj : "last4" Data.Aeson.Types.ToJSON..= sourceMandateNotificationSepaDebitDataLast4 obj : "mandate_reference" Data.Aeson.Types.ToJSON..= sourceMandateNotificationSepaDebitDataMandateReference obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("creditor_identifier" Data.Aeson.Types.ToJSON..= sourceMandateNotificationSepaDebitDataCreditorIdentifier obj) GHC.Base.<> (("last4" Data.Aeson.Types.ToJSON..= sourceMandateNotificationSepaDebitDataLast4 obj) GHC.Base.<> ("mandate_reference" Data.Aeson.Types.ToJSON..= sourceMandateNotificationSepaDebitDataMandateReference obj)))

instance Data.Aeson.Types.FromJSON.FromJSON SourceMandateNotificationSepaDebitData where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "SourceMandateNotificationSepaDebitData" (\obj -> ((GHC.Base.pure SourceMandateNotificationSepaDebitData GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "creditor_identifier")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "last4")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "mandate_reference"))

-- | Create a new 'SourceMandateNotificationSepaDebitData' with all required fields.
mkSourceMandateNotificationSepaDebitData :: SourceMandateNotificationSepaDebitData
mkSourceMandateNotificationSepaDebitData =
  SourceMandateNotificationSepaDebitData
    { sourceMandateNotificationSepaDebitDataCreditorIdentifier = GHC.Maybe.Nothing,
      sourceMandateNotificationSepaDebitDataLast4 = GHC.Maybe.Nothing,
      sourceMandateNotificationSepaDebitDataMandateReference = GHC.Maybe.Nothing
    }
