{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postIssuingCardholdersCardholder
module StripeAPI.Operations.PostIssuingCardholdersCardholder where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/issuing/cardholders/{cardholder}
--
-- \<p>Updates the specified Issuing \<code>Cardholder\<\/code> object by setting the values of the parameters passed. Any parameters not provided will be left unchanged.\<\/p>
postIssuingCardholdersCardholder ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | cardholder | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostIssuingCardholdersCardholderResponse)
postIssuingCardholdersCardholder
  cardholder
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostIssuingCardholdersCardholderResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostIssuingCardholdersCardholderResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Issuing'cardholder
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostIssuingCardholdersCardholderResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/issuing/cardholders/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel cardholder)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostIssuingCardholdersCardholderRequestBody = PostIssuingCardholdersCardholderRequestBody
  { -- | billing: The cardholder\'s billing address.
    postIssuingCardholdersCardholderRequestBodyBilling :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyBilling'),
    -- | company: Additional information about a \`company\` cardholder.
    postIssuingCardholdersCardholderRequestBodyCompany :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyCompany'),
    -- | email: The cardholder\'s email address.
    postIssuingCardholdersCardholderRequestBodyEmail :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | expand: Specifies which fields in the response should be expanded.
    postIssuingCardholdersCardholderRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | individual: Additional information about an \`individual\` cardholder.
    postIssuingCardholdersCardholderRequestBodyIndividual :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyIndividual'),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postIssuingCardholdersCardholderRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | phone_number: The cardholder\'s phone number.
    postIssuingCardholdersCardholderRequestBodyPhoneNumber :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | spending_controls: Rules that control spending across this cardholder\'s cards. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
    postIssuingCardholdersCardholderRequestBodySpendingControls :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodySpendingControls'),
    -- | status: Specifies whether to permit authorizations on this cardholder\'s cards.
    postIssuingCardholdersCardholderRequestBodyStatus :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyStatus')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object ("billing" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling obj : "company" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyCompany obj : "email" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyEmail obj : "expand" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyExpand obj : "individual" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual obj : "metadata" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyMetadata obj : "phone_number" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyPhoneNumber obj : "spending_controls" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls obj : "status" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyStatus obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("billing" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling obj) GHC.Base.<> (("company" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyCompany obj) GHC.Base.<> (("email" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyEmail obj) GHC.Base.<> (("expand" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyExpand obj) GHC.Base.<> (("individual" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyMetadata obj) GHC.Base.<> (("phone_number" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyPhoneNumber obj) GHC.Base.<> (("spending_controls" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls obj) GHC.Base.<> ("status" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyStatus obj)))))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBody" (\obj -> ((((((((GHC.Base.pure PostIssuingCardholdersCardholderRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "billing")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "company")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "individual")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "phone_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_controls")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "status"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBody' with all required fields.
mkPostIssuingCardholdersCardholderRequestBody :: PostIssuingCardholdersCardholderRequestBody
mkPostIssuingCardholdersCardholderRequestBody =
  PostIssuingCardholdersCardholderRequestBody
    { postIssuingCardholdersCardholderRequestBodyBilling = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyCompany = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyEmail = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyExpand = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyIndividual = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyMetadata = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyPhoneNumber = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodySpendingControls = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyStatus = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing@ in the specification.
--
-- The cardholder\'s billing address.
data PostIssuingCardholdersCardholderRequestBodyBilling' = PostIssuingCardholdersCardholderRequestBodyBilling'
  { -- | address
    postIssuingCardholdersCardholderRequestBodyBilling'Address :: PostIssuingCardholdersCardholderRequestBodyBilling'Address'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyBilling' where
  toJSON obj = Data.Aeson.Types.Internal.object ("address" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("address" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyBilling' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyBilling'" (\obj -> GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyBilling' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "address"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyBilling'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyBilling' ::
  -- | 'postIssuingCardholdersCardholderRequestBodyBilling'Address'
  PostIssuingCardholdersCardholderRequestBodyBilling'Address' ->
  PostIssuingCardholdersCardholderRequestBodyBilling'
mkPostIssuingCardholdersCardholderRequestBodyBilling' postIssuingCardholdersCardholderRequestBodyBilling'Address = PostIssuingCardholdersCardholderRequestBodyBilling' {postIssuingCardholdersCardholderRequestBodyBilling'Address = postIssuingCardholdersCardholderRequestBodyBilling'Address}

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing.properties.address@ in the specification.
data PostIssuingCardholdersCardholderRequestBodyBilling'Address' = PostIssuingCardholdersCardholderRequestBodyBilling'Address'
  { -- | city
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyBilling'Address'City :: Data.Text.Internal.Text,
    -- | country
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyBilling'Address'Country :: Data.Text.Internal.Text,
    -- | line1
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1 :: Data.Text.Internal.Text,
    -- | line2
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyBilling'Address'Line2 :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | postal_code
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode :: Data.Text.Internal.Text,
    -- | state
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyBilling'Address'State :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyBilling'Address' where
  toJSON obj = Data.Aeson.Types.Internal.object ("city" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'City obj : "country" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'Country obj : "line1" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1 obj : "line2" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'Line2 obj : "postal_code" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode obj : "state" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'State obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("city" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'City obj) GHC.Base.<> (("country" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'Country obj) GHC.Base.<> (("line1" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1 obj) GHC.Base.<> (("line2" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'Line2 obj) GHC.Base.<> (("postal_code" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode obj) GHC.Base.<> ("state" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyBilling'Address'State obj))))))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyBilling'Address' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyBilling'Address'" (\obj -> (((((GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyBilling'Address' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "city")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "country")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "line1")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "line2")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "postal_code")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "state"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyBilling'Address'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyBilling'Address' ::
  -- | 'postIssuingCardholdersCardholderRequestBodyBilling'Address'City'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersCardholderRequestBodyBilling'Address'Country'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode'
  Data.Text.Internal.Text ->
  PostIssuingCardholdersCardholderRequestBodyBilling'Address'
mkPostIssuingCardholdersCardholderRequestBodyBilling'Address' postIssuingCardholdersCardholderRequestBodyBilling'Address'City postIssuingCardholdersCardholderRequestBodyBilling'Address'Country postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1 postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode =
  PostIssuingCardholdersCardholderRequestBodyBilling'Address'
    { postIssuingCardholdersCardholderRequestBodyBilling'Address'City = postIssuingCardholdersCardholderRequestBodyBilling'Address'City,
      postIssuingCardholdersCardholderRequestBodyBilling'Address'Country = postIssuingCardholdersCardholderRequestBodyBilling'Address'Country,
      postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1 = postIssuingCardholdersCardholderRequestBodyBilling'Address'Line1,
      postIssuingCardholdersCardholderRequestBodyBilling'Address'Line2 = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode = postIssuingCardholdersCardholderRequestBodyBilling'Address'PostalCode,
      postIssuingCardholdersCardholderRequestBodyBilling'Address'State = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.company@ in the specification.
--
-- Additional information about a \`company\` cardholder.
data PostIssuingCardholdersCardholderRequestBodyCompany' = PostIssuingCardholdersCardholderRequestBodyCompany'
  { -- | tax_id
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyCompany'TaxId :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyCompany' where
  toJSON obj = Data.Aeson.Types.Internal.object ("tax_id" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyCompany'TaxId obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("tax_id" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyCompany'TaxId obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyCompany' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyCompany'" (\obj -> GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyCompany' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "tax_id"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyCompany'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyCompany' :: PostIssuingCardholdersCardholderRequestBodyCompany'
mkPostIssuingCardholdersCardholderRequestBodyCompany' = PostIssuingCardholdersCardholderRequestBodyCompany' {postIssuingCardholdersCardholderRequestBodyCompany'TaxId = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual@ in the specification.
--
-- Additional information about an \`individual\` cardholder.
data PostIssuingCardholdersCardholderRequestBodyIndividual' = PostIssuingCardholdersCardholderRequestBodyIndividual'
  { -- | dob
    postIssuingCardholdersCardholderRequestBodyIndividual'Dob :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyIndividual'Dob'),
    -- | first_name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyIndividual'FirstName :: Data.Text.Internal.Text,
    -- | last_name
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyIndividual'LastName :: Data.Text.Internal.Text,
    -- | verification
    postIssuingCardholdersCardholderRequestBodyIndividual'Verification :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyIndividual'Verification')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyIndividual' where
  toJSON obj = Data.Aeson.Types.Internal.object ("dob" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob obj : "first_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'FirstName obj : "last_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'LastName obj : "verification" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("dob" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob obj) GHC.Base.<> (("first_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'FirstName obj) GHC.Base.<> (("last_name" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'LastName obj) GHC.Base.<> ("verification" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification obj))))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyIndividual' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyIndividual'" (\obj -> (((GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyIndividual' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "dob")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "first_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "last_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "verification"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyIndividual'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyIndividual' ::
  -- | 'postIssuingCardholdersCardholderRequestBodyIndividual'FirstName'
  Data.Text.Internal.Text ->
  -- | 'postIssuingCardholdersCardholderRequestBodyIndividual'LastName'
  Data.Text.Internal.Text ->
  PostIssuingCardholdersCardholderRequestBodyIndividual'
mkPostIssuingCardholdersCardholderRequestBodyIndividual' postIssuingCardholdersCardholderRequestBodyIndividual'FirstName postIssuingCardholdersCardholderRequestBodyIndividual'LastName =
  PostIssuingCardholdersCardholderRequestBodyIndividual'
    { postIssuingCardholdersCardholderRequestBodyIndividual'Dob = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyIndividual'FirstName = postIssuingCardholdersCardholderRequestBodyIndividual'FirstName,
      postIssuingCardholdersCardholderRequestBodyIndividual'LastName = postIssuingCardholdersCardholderRequestBodyIndividual'LastName,
      postIssuingCardholdersCardholderRequestBodyIndividual'Verification = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual.properties.dob@ in the specification.
data PostIssuingCardholdersCardholderRequestBodyIndividual'Dob' = PostIssuingCardholdersCardholderRequestBodyIndividual'Dob'
  { -- | day
    postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day :: GHC.Types.Int,
    -- | month
    postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month :: GHC.Types.Int,
    -- | year
    postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyIndividual'Dob' where
  toJSON obj = Data.Aeson.Types.Internal.object ("day" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day obj : "month" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month obj : "year" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("day" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day obj) GHC.Base.<> (("month" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month obj) GHC.Base.<> ("year" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyIndividual'Dob' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyIndividual'Dob'" (\obj -> ((GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyIndividual'Dob' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "day")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "year"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyIndividual'Dob'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyIndividual'Dob' ::
  -- | 'postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day'
  GHC.Types.Int ->
  -- | 'postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month'
  GHC.Types.Int ->
  -- | 'postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year'
  GHC.Types.Int ->
  PostIssuingCardholdersCardholderRequestBodyIndividual'Dob'
mkPostIssuingCardholdersCardholderRequestBodyIndividual'Dob' postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year =
  PostIssuingCardholdersCardholderRequestBodyIndividual'Dob'
    { postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day = postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Day,
      postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month = postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Month,
      postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year = postIssuingCardholdersCardholderRequestBodyIndividual'Dob'Year
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual.properties.verification@ in the specification.
data PostIssuingCardholdersCardholderRequestBodyIndividual'Verification' = PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'
  { -- | document
    postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document :: (GHC.Maybe.Maybe PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyIndividual'Verification' where
  toJSON obj = Data.Aeson.Types.Internal.object ("document" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs ("document" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document obj)

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyIndividual'Verification' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'" (\obj -> GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyIndividual'Verification' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "document"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyIndividual'Verification' :: PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'
mkPostIssuingCardholdersCardholderRequestBodyIndividual'Verification' = PostIssuingCardholdersCardholderRequestBodyIndividual'Verification' {postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.individual.properties.verification.properties.document@ in the specification.
data PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document' = PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'
  { -- | back
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Back :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | front
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Front :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document' where
  toJSON obj = Data.Aeson.Types.Internal.object ("back" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Back obj : "front" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Front obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("back" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Back obj) GHC.Base.<> ("front" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Front obj))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'" (\obj -> (GHC.Base.pure PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "back")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "front"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document' :: PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'
mkPostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document' =
  PostIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'
    { postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Back = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodyIndividual'Verification'Document'Front = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls@ in the specification.
--
-- Rules that control spending across this cardholder\'s cards. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
data PostIssuingCardholdersCardholderRequestBodySpendingControls' = PostIssuingCardholdersCardholderRequestBodySpendingControls'
  { -- | allowed_categories
    postIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'])),
    -- | blocked_categories
    postIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'])),
    -- | spending_limits
    postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits :: (GHC.Maybe.Maybe ([PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'])),
    -- | spending_limits_currency
    postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimitsCurrency :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodySpendingControls' where
  toJSON obj = Data.Aeson.Types.Internal.object ("allowed_categories" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories obj : "blocked_categories" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories obj : "spending_limits" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits obj : "spending_limits_currency" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimitsCurrency obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("allowed_categories" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories obj) GHC.Base.<> (("blocked_categories" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories obj) GHC.Base.<> (("spending_limits" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits obj) GHC.Base.<> ("spending_limits_currency" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimitsCurrency obj))))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodySpendingControls' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodySpendingControls'" (\obj -> (((GHC.Base.pure PostIssuingCardholdersCardholderRequestBodySpendingControls' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits_currency"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodySpendingControls'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodySpendingControls' :: PostIssuingCardholdersCardholderRequestBodySpendingControls'
mkPostIssuingCardholdersCardholderRequestBodySpendingControls' =
  PostIssuingCardholdersCardholderRequestBodySpendingControls'
    { postIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimitsCurrency = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.allowed_categories.items@ in the specification.
data PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories' where
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'Other val) = val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardholdersCardholderRequestBodySpendingControls'AllowedCategories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.blocked_categories.items@ in the specification.
data PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories' where
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'Other val) = val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardholdersCardholderRequestBodySpendingControls'BlockedCategories'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items@ in the specification.
data PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits' = PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'
  { -- | amount
    postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount :: GHC.Types.Int,
    -- | categories
    postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories :: (GHC.Maybe.Maybe ([PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'])),
    -- | interval
    postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval :: PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits' where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount obj : "categories" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories obj : "interval" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount obj) GHC.Base.<> (("categories" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories obj) GHC.Base.<> ("interval" Data.Aeson.Types.ToJSON..= postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'" (\obj -> ((GHC.Base.pure PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval"))

-- | Create a new 'PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'' with all required fields.
mkPostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits' ::
  -- | 'postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount'
  GHC.Types.Int ->
  -- | 'postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'
  PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval' ->
  PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'
mkPostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits' postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval =
  PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'
    { postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount = postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Amount,
      postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories = GHC.Maybe.Nothing,
      postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval = postIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.categories.items@ in the specification.
data PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories' where
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'Other val) = val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Categories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.interval@ in the specification.
data PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"all_time"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
  | -- | Represents the JSON value @"daily"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
  | -- | Represents the JSON value @"monthly"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
  | -- | Represents the JSON value @"per_authorization"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
  | -- | Represents the JSON value @"weekly"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
  | -- | Represents the JSON value @"yearly"@
    PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval' where
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'Other val) = val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime) = "all_time"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily) = "daily"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly) = "monthly"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization) = "per_authorization"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly) = "weekly"
  toJSON (PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly) = "yearly"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "all_time" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
            | val GHC.Classes.== "daily" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
            | val GHC.Classes.== "monthly" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
            | val GHC.Classes.== "per_authorization" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
            | val GHC.Classes.== "weekly" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
            | val GHC.Classes.== "yearly" -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
            | GHC.Base.otherwise -> PostIssuingCardholdersCardholderRequestBodySpendingControls'SpendingLimits'Interval'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cardholders\/{cardholder}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.status@ in the specification.
--
-- Specifies whether to permit authorizations on this cardholder\'s cards.
data PostIssuingCardholdersCardholderRequestBodyStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardholdersCardholderRequestBodyStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardholdersCardholderRequestBodyStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    PostIssuingCardholdersCardholderRequestBodyStatus'EnumActive
  | -- | Represents the JSON value @"inactive"@
    PostIssuingCardholdersCardholderRequestBodyStatus'EnumInactive
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardholdersCardholderRequestBodyStatus' where
  toJSON (PostIssuingCardholdersCardholderRequestBodyStatus'Other val) = val
  toJSON (PostIssuingCardholdersCardholderRequestBodyStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardholdersCardholderRequestBodyStatus'EnumActive) = "active"
  toJSON (PostIssuingCardholdersCardholderRequestBodyStatus'EnumInactive) = "inactive"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardholdersCardholderRequestBodyStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> PostIssuingCardholdersCardholderRequestBodyStatus'EnumActive
            | val GHC.Classes.== "inactive" -> PostIssuingCardholdersCardholderRequestBodyStatus'EnumInactive
            | GHC.Base.otherwise -> PostIssuingCardholdersCardholderRequestBodyStatus'Other val
      )

-- | Represents a response of the operation 'postIssuingCardholdersCardholder'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostIssuingCardholdersCardholderResponseError' is used.
data PostIssuingCardholdersCardholderResponse
  = -- | Means either no matching case available or a parse error
    PostIssuingCardholdersCardholderResponseError GHC.Base.String
  | -- | Successful response.
    PostIssuingCardholdersCardholderResponse200 Issuing'cardholder
  | -- | Error response.
    PostIssuingCardholdersCardholderResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
