{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postIssuingCardsCard
module StripeAPI.Operations.PostIssuingCardsCard where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/issuing/cards/{card}
--
-- \<p>Updates the specified Issuing \<code>Card\<\/code> object by setting the values of the parameters passed. Any parameters not provided will be left unchanged.\<\/p>
postIssuingCardsCard ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | card | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostIssuingCardsCardRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostIssuingCardsCardResponse)
postIssuingCardsCard
  card
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostIssuingCardsCardResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostIssuingCardsCardResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Issuing'card
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostIssuingCardsCardResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/issuing/cards/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel card)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostIssuingCardsCardRequestBody = PostIssuingCardsCardRequestBody
  { -- | cancellation_reason: Reason why the \`status\` of this card is \`canceled\`.
    postIssuingCardsCardRequestBodyCancellationReason :: (GHC.Maybe.Maybe PostIssuingCardsCardRequestBodyCancellationReason'),
    -- | expand: Specifies which fields in the response should be expanded.
    postIssuingCardsCardRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postIssuingCardsCardRequestBodyMetadata :: (GHC.Maybe.Maybe PostIssuingCardsCardRequestBodyMetadata'Variants),
    -- | spending_controls: Rules that control spending for this card. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
    postIssuingCardsCardRequestBodySpendingControls :: (GHC.Maybe.Maybe PostIssuingCardsCardRequestBodySpendingControls'),
    -- | status: Dictates whether authorizations can be approved on this card. If this card is being canceled because it was lost or stolen, this information should be provided as \`cancellation_reason\`.
    postIssuingCardsCardRequestBodyStatus :: (GHC.Maybe.Maybe PostIssuingCardsCardRequestBodyStatus')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object ("cancellation_reason" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyCancellationReason obj : "expand" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyExpand obj : "metadata" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyMetadata obj : "spending_controls" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls obj : "status" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyStatus obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("cancellation_reason" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyCancellationReason obj) GHC.Base.<> (("expand" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyExpand obj) GHC.Base.<> (("metadata" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyMetadata obj) GHC.Base.<> (("spending_controls" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls obj) GHC.Base.<> ("status" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodyStatus obj)))))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsCardRequestBody" (\obj -> ((((GHC.Base.pure PostIssuingCardsCardRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "cancellation_reason")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_controls")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "status"))

-- | Create a new 'PostIssuingCardsCardRequestBody' with all required fields.
mkPostIssuingCardsCardRequestBody :: PostIssuingCardsCardRequestBody
mkPostIssuingCardsCardRequestBody =
  PostIssuingCardsCardRequestBody
    { postIssuingCardsCardRequestBodyCancellationReason = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodyExpand = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodyMetadata = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodySpendingControls = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodyStatus = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.cancellation_reason@ in the specification.
--
-- Reason why the \`status\` of this card is \`canceled\`.
data PostIssuingCardsCardRequestBodyCancellationReason'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsCardRequestBodyCancellationReason'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsCardRequestBodyCancellationReason'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"lost"@
    PostIssuingCardsCardRequestBodyCancellationReason'EnumLost
  | -- | Represents the JSON value @"stolen"@
    PostIssuingCardsCardRequestBodyCancellationReason'EnumStolen
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodyCancellationReason' where
  toJSON (PostIssuingCardsCardRequestBodyCancellationReason'Other val) = val
  toJSON (PostIssuingCardsCardRequestBodyCancellationReason'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsCardRequestBodyCancellationReason'EnumLost) = "lost"
  toJSON (PostIssuingCardsCardRequestBodyCancellationReason'EnumStolen) = "stolen"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodyCancellationReason' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "lost" -> PostIssuingCardsCardRequestBodyCancellationReason'EnumLost
            | val GHC.Classes.== "stolen" -> PostIssuingCardsCardRequestBodyCancellationReason'EnumStolen
            | GHC.Base.otherwise -> PostIssuingCardsCardRequestBodyCancellationReason'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.metadata.anyOf@ in the specification.
--
-- Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
data PostIssuingCardsCardRequestBodyMetadata'Variants
  = -- | Represents the JSON value @""@
    PostIssuingCardsCardRequestBodyMetadata'EmptyString
  | PostIssuingCardsCardRequestBodyMetadata'Object Data.Aeson.Types.Internal.Object
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodyMetadata'Variants where
  toJSON (PostIssuingCardsCardRequestBodyMetadata'Object a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostIssuingCardsCardRequestBodyMetadata'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodyMetadata'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostIssuingCardsCardRequestBodyMetadata'EmptyString
        | GHC.Base.otherwise -> case (PostIssuingCardsCardRequestBodyMetadata'Object Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls@ in the specification.
--
-- Rules that control spending for this card. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
data PostIssuingCardsCardRequestBodySpendingControls' = PostIssuingCardsCardRequestBodySpendingControls'
  { -- | allowed_categories
    postIssuingCardsCardRequestBodySpendingControls'AllowedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'])),
    -- | blocked_categories
    postIssuingCardsCardRequestBodySpendingControls'BlockedCategories :: (GHC.Maybe.Maybe ([PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'])),
    -- | spending_limits
    postIssuingCardsCardRequestBodySpendingControls'SpendingLimits :: (GHC.Maybe.Maybe ([PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodySpendingControls' where
  toJSON obj = Data.Aeson.Types.Internal.object ("allowed_categories" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'AllowedCategories obj : "blocked_categories" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'BlockedCategories obj : "spending_limits" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("allowed_categories" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'AllowedCategories obj) GHC.Base.<> (("blocked_categories" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'BlockedCategories obj) GHC.Base.<> ("spending_limits" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodySpendingControls' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsCardRequestBodySpendingControls'" (\obj -> ((GHC.Base.pure PostIssuingCardsCardRequestBodySpendingControls' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "spending_limits"))

-- | Create a new 'PostIssuingCardsCardRequestBodySpendingControls'' with all required fields.
mkPostIssuingCardsCardRequestBodySpendingControls' :: PostIssuingCardsCardRequestBodySpendingControls'
mkPostIssuingCardsCardRequestBodySpendingControls' =
  PostIssuingCardsCardRequestBodySpendingControls'
    { postIssuingCardsCardRequestBodySpendingControls'AllowedCategories = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodySpendingControls'BlockedCategories = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodySpendingControls'SpendingLimits = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.allowed_categories.items@ in the specification.
data PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories' where
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'Other val) = val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardsCardRequestBodySpendingControls'AllowedCategories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.blocked_categories.items@ in the specification.
data PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories' where
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'Other val) = val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardsCardRequestBodySpendingControls'BlockedCategories'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items@ in the specification.
data PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits' = PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'
  { -- | amount
    postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount :: GHC.Types.Int,
    -- | categories
    postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories :: (GHC.Maybe.Maybe ([PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'])),
    -- | interval
    postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval :: PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits' where
  toJSON obj = Data.Aeson.Types.Internal.object ("amount" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount obj : "categories" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories obj : "interval" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval obj : GHC.Base.mempty)
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (("amount" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount obj) GHC.Base.<> (("categories" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories obj) GHC.Base.<> ("interval" Data.Aeson.Types.ToJSON..= postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval obj)))

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'" (\obj -> ((GHC.Base.pure PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "interval"))

-- | Create a new 'PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'' with all required fields.
mkPostIssuingCardsCardRequestBodySpendingControls'SpendingLimits' ::
  -- | 'postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount'
  GHC.Types.Int ->
  -- | 'postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'
  PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval' ->
  PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'
mkPostIssuingCardsCardRequestBodySpendingControls'SpendingLimits' postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval =
  PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'
    { postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount = postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Amount,
      postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories = GHC.Maybe.Nothing,
      postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval = postIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval
    }

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.categories.items@ in the specification.
data PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories' where
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'Other val) = val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices) = "advertising_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices) = "ambulance_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions) = "antique_reproductions"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops) = "antique_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums) = "aquariums"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops) = "auto_paint_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops) = "auto_service_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations) = "automobile_associations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries) = "bakeries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras) = "bands_orchestras"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops) = "bicycle_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers) = "boat_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores) = "book_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys) = "bowling_alleys"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines) = "bus_lines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes) = "car_washes"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices) = "carpentry_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers) = "caterers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices) = "child_care_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors) = "chiropractors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental) = "clothing_rental"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities) = "colleges_universities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment) = "commercial_equipment"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear) = "commercial_footwear"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices) = "computer_network_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming) = "computer_programming"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair) = "computer_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices) = "concrete_work_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials) = "construction_materials"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores) = "cosmetic_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices) = "counseling_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs) = "country_clubs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices) = "courier_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts) = "court_costs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines) = "cruise_lines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores) = "dairy_products_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices) = "dating_escort_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores) = "department_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies) = "detective_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores) = "discount_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors) = "doctors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces) = "drinking_places"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners) = "dry_cleaners"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods) = "durable_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores) = "duty_free_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices) = "educational_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores) = "electric_razor_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices) = "electrical_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores) = "electronics_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental) = "equipment_rental"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices) = "exterminating_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions) = "financial_institutions"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists) = "florists"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices) = "general_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices) = "government_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores) = "hardware_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals) = "hospitals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies) = "industrial_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault) = "insurance_default"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices) = "landscaping_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries) = "laundries"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors) = "massage_parlors"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices) = "medical_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations) = "membership_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters) = "metal_service_centers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous) = "miscellaneous"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods) = "nondurable_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths) = "osteopaths"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways) = "passenger_railways"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops) = "pawn_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping) = "photo_developing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios) = "photographic_studios"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction) = "picture_video_production"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations) = "political_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices) = "professional_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads) = "railroads"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores) = "record_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations) = "religious_organizations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations) = "service_stations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores) = "shoe_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices) = "special_trade_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations) = "tailors_alterations"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices) = "telecommunication_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices) = "telegraph_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories) = "testing_laboratories"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares) = "timeshares"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices) = "towing_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices) = "transportation_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores) = "typewriter_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities) = "utilities"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores) = "variety_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices) = "veterinary_services"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades) = "video_game_arcades"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair) = "welding_repair"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs) = "wholesale_clubs"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCountryClubs
            | val GHC.Classes.== "courier_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCourierServices
            | val GHC.Classes.== "court_costs" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDiscountStores
            | val GHC.Classes.== "doctors" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLandscapingServices
            | val GHC.Classes.== "laundries" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumUtilities
            | val GHC.Classes.== "variety_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'EnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Categories'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.spending_controls.properties.spending_limits.items.properties.interval@ in the specification.
data PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"all_time"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
  | -- | Represents the JSON value @"daily"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
  | -- | Represents the JSON value @"monthly"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
  | -- | Represents the JSON value @"per_authorization"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
  | -- | Represents the JSON value @"weekly"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
  | -- | Represents the JSON value @"yearly"@
    PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval' where
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'Other val) = val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime) = "all_time"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily) = "daily"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly) = "monthly"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization) = "per_authorization"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly) = "weekly"
  toJSON (PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly) = "yearly"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "all_time" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumAllTime
            | val GHC.Classes.== "daily" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumDaily
            | val GHC.Classes.== "monthly" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumMonthly
            | val GHC.Classes.== "per_authorization" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumPerAuthorization
            | val GHC.Classes.== "weekly" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumWeekly
            | val GHC.Classes.== "yearly" -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'EnumYearly
            | GHC.Base.otherwise -> PostIssuingCardsCardRequestBodySpendingControls'SpendingLimits'Interval'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/issuing\/cards\/{card}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.status@ in the specification.
--
-- Dictates whether authorizations can be approved on this card. If this card is being canceled because it was lost or stolen, this information should be provided as \`cancellation_reason\`.
data PostIssuingCardsCardRequestBodyStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostIssuingCardsCardRequestBodyStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostIssuingCardsCardRequestBodyStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    PostIssuingCardsCardRequestBodyStatus'EnumActive
  | -- | Represents the JSON value @"canceled"@
    PostIssuingCardsCardRequestBodyStatus'EnumCanceled
  | -- | Represents the JSON value @"inactive"@
    PostIssuingCardsCardRequestBodyStatus'EnumInactive
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostIssuingCardsCardRequestBodyStatus' where
  toJSON (PostIssuingCardsCardRequestBodyStatus'Other val) = val
  toJSON (PostIssuingCardsCardRequestBodyStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostIssuingCardsCardRequestBodyStatus'EnumActive) = "active"
  toJSON (PostIssuingCardsCardRequestBodyStatus'EnumCanceled) = "canceled"
  toJSON (PostIssuingCardsCardRequestBodyStatus'EnumInactive) = "inactive"

instance Data.Aeson.Types.FromJSON.FromJSON PostIssuingCardsCardRequestBodyStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> PostIssuingCardsCardRequestBodyStatus'EnumActive
            | val GHC.Classes.== "canceled" -> PostIssuingCardsCardRequestBodyStatus'EnumCanceled
            | val GHC.Classes.== "inactive" -> PostIssuingCardsCardRequestBodyStatus'EnumInactive
            | GHC.Base.otherwise -> PostIssuingCardsCardRequestBodyStatus'Other val
      )

-- | Represents a response of the operation 'postIssuingCardsCard'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostIssuingCardsCardResponseError' is used.
data PostIssuingCardsCardResponse
  = -- | Means either no matching case available or a parse error
    PostIssuingCardsCardResponseError GHC.Base.String
  | -- | Successful response.
    PostIssuingCardsCardResponse200 Issuing'card
  | -- | Error response.
    PostIssuingCardsCardResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
